import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Solution to Sequences
 * 
 * @author vanb
 */
public class sequences_vanb
{
    private static Scanner sc;
    private static PrintStream ps;
    
    private void doit()
    {
        int firstx=0, firsti=0, idiff=0, xdiff=0;
        for( int i=0; i<10; i++ )
        {
            int x = sc.nextInt();
            if( x>0 )
            {
                if( firstx==0 )
                {
                    firstx = x;
                    firsti = i;
                }
                else
                {
                    xdiff = x-firstx;
                    idiff = i-firsti;
                }
            }
        }
        
        if( xdiff%idiff != 0 )
        {
            ps.println( -1 );
        }
        else
        {
            int factor = xdiff/idiff;
            for( int i=0; i<10; i++ )
            {
                ps.print( (i==0?"":" ") + (firstx + (i-firsti)*factor) );
            }
            ps.println();
        }
    }
        
    public static void main( String[] args ) throws Exception
    {
        sc = new Scanner( System.in );
        ps = System.out;
        
        new sequences_vanb().doit();
    }

}
